/*
 * Copyright 2017-2020, Schlumberger
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.opengroup.osdu.register.action;

import org.opengroup.osdu.register.util.BaseTestTemplate;
import org.opengroup.osdu.register.util.RestDescriptor;
import com.sun.jersey.api.client.ClientResponse;


public abstract class RetrieveActionApiTest extends BaseTestTemplate {

    public RetrieveActionApiTest() {
        super(new RetrieveActionDescriptor());
        this.createDescriptor = new CreateActionDescriptor();
        this.deleteDescriptor = new DeleteActionDescriptor();
    }

    protected RestDescriptor createDescriptor;
    protected RestDescriptor deleteDescriptor;
    private String id = "retrieveactiontest" + System.currentTimeMillis();


    @Override
    protected boolean isDataInTenant() {
        return true;
    }

    @Override
    protected String getId() {
        return id;
    }

    @Override
    protected void validate20XResponse(ClientResponse response, RestDescriptor descriptor) {

    }

    @Override
    protected void deleteResource() throws Exception {
        deleteDescriptor.run(getId(), testUtils.getOpsAccessToken());
    }

    @Override
    protected void createResource() throws Exception {
        createDescriptor.run(getId(), testUtils.getOpsAccessToken());
    }

    @Override
    protected int expectedOkResponseCode() {
        return 200;
    }
}
